org.apache.sling.featureflags

## Interface Feature

All Known Implementing Classes:
  ConfiguredFeature

    @ConsumerType
    public interface Feature

A feature is defined by its name. Features are registered as OSGi services.

Feature `names` should be globally unique. If multiple features have the same name, the feature with the highest service ranking is accessible through the `Features` service while those with lower service rankings are ignored.

This interface is expected to be implemented by feature providers.

### Method Summary

Methods
`String` `getDescription()` The description of the feature.
`String` `getName()` The name of the feature.
`boolean` `isEnabled(ExecutionContext context)` Checks whether the feature is enabled for the given execution context.

### Method Detail

#### getName

    String getName()

The name of the feature.

Returns:
  The name of this feature which must not be `null` or an empty string.

#### getDescription

    String getDescription()

The description of the feature.

Returns:
  The optional description of this feature, which may be `null` or an empty string.

#### isEnabled

    boolean isEnabled(ExecutionContext context)

Checks whether the feature is enabled for the given execution context.

Multiple calls to this method may but are not required to return the same value. For example the return value may depend on the time of day, some random number or some information provided by the given `ExecutionContext`.

This method is called by the `Feature` manager and is not intended to be called by application code directly.

Parameters:
  `context` - The `ExecutionContext` providing a context to evaluate whether the feature is enabled or not. Implementations must not hold on to this context instance or the values provided for longer than executing this method.
Returns:
  `true` if this `Feature` is enabled in the given `ExecutionContext`.